<?php

global $user, $lang, $conf, $errors;

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
// +-----------------------------------------------------------------------+
// | Check Access and exit when user status is not ok                      |
// +-----------------------------------------------------------------------+
check_status(ACCESS_ADMINISTRATOR);

if (!defined('LCAS_PATH')) define('LCAS_PATH' , PHPWG_PLUGINS_PATH.basename(dirname(__FILE__)).'/');

//ini_set('error_reporting', E_ALL);
//ini_set('display_errors', true);

include_once(PHPWG_ROOT_PATH.'include/constants.php');
include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');
$my_base_url = get_admin_plugin_menu_link(__FILE__);

load_language('plugin.lang', LCAS_PATH);
load_language('help/plugin.lang', LCAS_PATH);

$error = array();

$t = pwg_db_fetch_row(pwg_query('
  SELECT `value`
  FROM `'.CONFIG_TABLE.'`
  WHERE `param` = "LoginCaseAccentsSensitivity"
  LIMIT 1;
'));

$conf['LoginCaseAccentsSensitivity'] = $t[0];

// +-----------------------------------------------------------------------+
// |                      Getting plugin version                           |
// +-----------------------------------------------------------------------+
$plugin =  LCAS_PluginInfos(LCAS_PATH);
$version = $plugin['version'];

	if (isset($_POST['submit']) and isset($_POST['LCAS_Option']) and isset($_POST['LCAS_Mail']))
  {

/* General configuration settings */
		$_POST['LCAS_MailText'] = str_replace('\"', '"', str_replace("\'", "'", str_replace("\\\\", "\\", $_POST['LCAS_MailText'])));
    
		// LCAS configuration is now hereby defined :
    // $conf_LCAS[0] : "final case", describe how LCAS should behave;
    // $conf_LCAS[1] : LCAS option, describe the choice of the webmaster;
    // $conf_LCAS[2] : LCAS_Mail;
    // $conf_LCAS[3] : LCAS_MailText.
    $newconf_LCAS= array(
      LCAS_final_case($_POST['LCAS_Option']),
      $_POST['LCAS_Option'],
      // $_POST['LCAS__spare'] : quite lazy, but convenient to not have to
      // decrease index of each option below everywhere :-/ ...
      $_POST['LCAS_Mail'],
      $_POST['LCAS_MailText']);

    $conf['LoginCaseAccentsSensitivity'] = serialize($newconf_LCAS);

		$query = '
	  	UPDATE '.CONFIG_TABLE.'
	  	SET value="'.addslashes($conf['LoginCaseAccentsSensitivity']).'"
	  	WHERE param="LoginCaseAccentsSensitivity"
	  	LIMIT 1
	  	;';
		
		pwg_query($query);

    array_push($page['infos'], l10n('LCAS_save_config'));
  }

	$conf_LCAS= unserialize($conf['LoginCaseAccentsSensitivity']);
  $conf_LCAS[0] = LCAS_final_case($conf_LCAS[1]);
  
  if (isset($conf_LCAS[0]))
  {
    // $conf['insensitive_case_logon'] must be true or false when needed
    if ($conf_LCAS[0]=='4' or $conf_LCAS[0]=='5')
     array_push($page['errors'], l10n('LCAS_warning'));
    elseif ($conf_LCAS[0]=='6' or $conf_LCAS[0]=='7')
     array_push($page['errors'], l10n('LCAS_warning2'));

    $case_ins = (in_array($conf_LCAS[0], array('1', '3','6','7')));
    $acc_ins = (in_array($conf_LCAS[0], array('2', '5', '3','6','7')));

    if ($case_ins or $acc_ins)
    {
// +-----------------------------------------------------------------------+
// |                           initialization                              |
// +-----------------------------------------------------------------------+

      $lcas_UserToUpdate = -1;
      if ((isset($_POST['UserToUpdate'])) && ($_POST['UserToUpdate'] != -1)) {
        $lcas_UserToUpdate = $_POST['UserToUpdate'];
        
        if ((isset($_POST['user-'.$lcas_UserToUpdate])) && ($_POST['user-'.$lcas_UserToUpdate] != '')) {
          // Vérifier si le nom n'est pas déjà pris
          
          
          
          // Mise à jour du nom
          $query = '
            UPDATE '.USERS_TABLE.'
            SET username="'.addslashes($_POST['user-'.$lcas_UserToUpdate]).'"
            WHERE id='.$lcas_UserToUpdate.'
            LIMIT 1
            ;';

          pwg_query($query);

        if (isset($conf_LCAS[2]) and $conf_LCAS[2] = 'true')
        {
          LCAS_SendMail($lcas_UserToUpdate, $_POST['user-'.$lcas_UserToUpdate]);
        }

          array_push($page['infos'], l10n('LCAS_Info_userlist_username_renamed'));
        }
        else {
          // User is empty
          array_push($page['errors'], l10n('LCAS_Err_Userlist_Empty_New_Username'));
        }
      }


// +-----------------------------------------------------------------------+
// |                               user list                               |
// +-----------------------------------------------------------------------+

      $page['all_users'] = LCAS_get_user_list($conf_LCAS[0]);

// +-----------------------------------------------------------------------+
// |                               user list                               |
// +-----------------------------------------------------------------------+

      $lcas_previous_compare_user = '';
      $visible_user_list          = array();
      foreach ($page['all_users'] as $local_user)
      {
        if ($lcas_previous_compare_user != $local_user['transformed']) {
          $display = 'orange';
          $lcas_previous_compare_user = $local_user['transformed'];
        }
        else {
          $display = '';
        }

        $template->append(
          'users',
          array(
            'ID'          => $local_user['id'],
            'USERNAME'    => stripslashes($local_user['username']),
            'COMPARE'     => stripslashes($local_user['transformed']),
            'EMAIL'       => get_email_address_as_display_text($local_user['email']),
            'DISPLAY'     => $display,
          )
        );
      }
      /* Plugin version insert */
      $template->assign(
        array(
          'LCAS_VERSION'  => $version,
          'LCAS_PATH'     => LCAS_PATH,
        )
      );    

      
// +-----------------------------------------------------------------------+
// |                             errors display                            |
// +-----------------------------------------------------------------------+
      if ( isset ($errors) and count($errors) != 0)
      {
        $template->assign('errors',array());
        foreach ($errors as $error)
        {
          array_push($page['errors'], $error);
        }
      }  

    }
  }


// +-----------------------------------------------------------------------+
// |                           templates init                              |
// +-----------------------------------------------------------------------+
  $template->assign(
    array(
    'LCAS_VERSION'                  => $version,
    'LCAS_PATH'                     => LCAS_PATH,
    'PWG_insensitive_case_logon'    => ($conf['insensitive_case_logon']),
    'Personalized_not_allowed'      => (!isset($conf['LCAS_replacement_set'][0])),
		'LCAS_final_case'               => $conf_LCAS[0],
		'LCAS_Option'                   => $conf_LCAS[1],
		'LCAS_MAIL_TRUE'                => $conf_LCAS[2]=='true'          ? 'checked="checked"' : '' ,
		'LCAS_MAIL_FALSE'               => $conf_LCAS[2]=='false'         ? 'checked="checked"' : '' ,
    'LCAS_MAILTEXT'                 => $conf_LCAS[3]
    )
  );


// +-----------------------------------------------------------------------+
// |                             errors display                            |
// +-----------------------------------------------------------------------+
  if (isset ($errors) and count($errors) != 0)
  {
	  $template->assign('errors',array());
	  foreach ($errors as $error)
	  {
		  array_push($page['errors'], $error);
		}
	}  

// +-----------------------------------------------------------------------+
// |                           templates display                           |
// +-----------------------------------------------------------------------+
  $template->set_filename('plugin_admin_content', dirname(__FILE__) . '/template/global.tpl');
  $template->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');

?>